VERSION 5.00
Begin VB.Form frmAddConnection 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Add connection"
   ClientHeight    =   4065
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6810
   Icon            =   "frmAddConnection.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4065
   ScaleWidth      =   6810
   StartUpPosition =   3  'Windows Default
   Tag             =   "frmAddConnection"
   Begin VB.Frame fraDirection 
      Caption         =   "Direction"
      Height          =   2055
      Left            =   120
      TabIndex        =   4
      Tag             =   "frmAddConnection.fraDirection"
      Top             =   1920
      Width           =   1935
      Begin VB.OptionButton optDirectionFrom 
         Caption         =   "From"
         Height          =   495
         Left            =   360
         TabIndex        =   7
         Tag             =   "frmAddConnection.optDirectionFrom"
         Top             =   1320
         Width           =   1455
      End
      Begin VB.OptionButton optDirectionTo 
         Caption         =   "To"
         Height          =   495
         Left            =   360
         TabIndex        =   6
         Tag             =   "frmAddConnection.optDirectionTo"
         Top             =   840
         Width           =   1455
      End
      Begin VB.OptionButton optDirectionNone 
         Caption         =   "None"
         Height          =   495
         Left            =   360
         TabIndex        =   5
         Tag             =   "frmAddConnection.optDirectionNone"
         Top             =   360
         Value           =   -1  'True
         Width           =   1455
      End
   End
   Begin VB.ListBox lstType 
      Height          =   1425
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   1935
   End
   Begin VB.ListBox lstNodes 
      Height          =   1425
      Left            =   2160
      TabIndex        =   3
      Top             =   360
      Width           =   4575
   End
   Begin VB.CommandButton cmdAddConnectionCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5520
      TabIndex        =   9
      Tag             =   "frmAddConnection.cmdAddConnectionCancel"
      Top             =   3600
      Width           =   1215
   End
   Begin VB.CommandButton cmdAddConnectionOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   5520
      TabIndex        =   8
      Top             =   3120
      Width           =   1215
   End
   Begin VB.Label lblType 
      Caption         =   "Connection type"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Tag             =   "frmAddConnection.lblType"
      Top             =   120
      Width           =   1935
   End
   Begin VB.Label lblConnectTo 
      Caption         =   "Connect &to"
      Height          =   495
      Left            =   2160
      TabIndex        =   2
      Tag             =   "frmAddConnection.lblConnectTo"
      ToolTipText     =   "frmAddConnection.lblConnectTo"
      Top             =   120
      Width           =   1815
   End
End
Attribute VB_Name = "frmAddConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private nodeIndex As Collection

Private Sub cmdAddConnectionCancel_Click()
    On Error Resume Next
    Call Me.Hide
End Sub

Private Sub cmdAddConnectionOK_Click()
    On Error Resume Next
    Dim newConnection As New CConnection
    Dim otherEnd As New CConnection
    Dim targetNode As CNode
    
    Set targetNode = nodeIndex.item(lstNodes.listIndex + 1)
    newConnection.target = targetNode.id
    newConnection.id = targetNode.id & "-" & GetTickCount
    newConnection.connectionType = lstType.List(lstType.listIndex) & " - "
    Call newConnection.DetermineName(currentNode)
    Call currentNode.AddConnection(newConnection)
    otherEnd.target = currentNode.id
    otherEnd.id = currentNode.id & "-" & GetTickCount
    otherEnd.connectionType = newConnection.connectionType
    Call otherEnd.DetermineName(targetNode)
    Call targetNode.AddConnection(otherEnd)
    Call Me.Hide
End Sub

Private Sub Form_Activate()
    On Error Resume Next
    'set up form for input
    Dim typeIterator As Variant
   
    cmdAddConnectionOK.Enabled = False
    
    Call lstType.Clear
    Call lstNodes.Clear
    For Each typeIterator In currentNode.allowedConnections
        Call lstType.AddItem(typeIterator)
    Next typeIterator
    Call lstType.SetFocus
End Sub

Private Sub Form_Load()
    On Error Resume Next
    Me.Icon = frmMain.Icon
End Sub

Private Sub lstNodes_Click()
    On Error Resume Next
    Call CheckOK
End Sub

Private Sub lstType_Click()
    On Error Resume Next
    'populate the list of nodes we can connect to
    Dim nodeIterator As CNode
    
    Call lstNodes.Clear
    Set nodeIndex = New Collection
    For Each nodeIterator In diagramNodes
        If frmMain.connectionTable.Allowed(currentNode.nodeType, nodeIterator.nodeType, lstType.List(lstType.listIndex)) Then
            Call lstNodes.AddItem(nodeIterator.nodeName & ": " & nodeIterator.nodeType)
            Call nodeIndex.add(nodeIterator)
        End If
    Next nodeIterator
    Call CheckOK
End Sub

Private Sub CheckOK()
    On Error Resume Next
    If lstType.listIndex > -1 And lstNodes.listIndex > -1 Then
        cmdAddConnectionOK.Enabled = True
    Else
        cmdAddConnectionOK.Enabled = False
    End If
End Sub

Private Sub optDirectionFrom_Click()
    On Error Resume Next
    optDirectionTo.Value = False
    optDirectionNone.Value = False
End Sub

Private Sub optDirectionNone_Click()
    On Error Resume Next
    optDirectionTo.Value = False
    optDirectionFrom.Value = False
End Sub

Private Sub optDirectionTo_Click()
    On Error Resume Next
    optDirectionNone.Value = False
    optDirectionFrom.Value = False
End Sub
